#include <Arduino.h>
#define PORT PWM_2
class HallButton // TODO
{
public:
  byte pin;
  HallButton(byte pin)
  {
    this->pin = pin;
  };
  void Pulse(unsigned long time, bool high = false)
  {
    if (high)
    {
      if(++count >= 8) count =0;
      highTime[count] = time - lastRead;
    }
    else
    {
      lowTime[count] = time - lastRead;
    }
    lastRead = time;
  }
  byte count = 0;
  unsigned long lastRead;
  unsigned long lowTime[8];
  unsigned long highTime[8];
  byte getPercent()
  {
    uint sumLow = 0;
    uint sumHigh = 0;
    for (size_t i = 0; i < sizeof(lowTime); i++)
    {
      sumLow += lowTime[i];
      sumHigh += highTime[i];
    }
    byte newPercent = 100 * sumHigh / (sumHigh + sumLow);
    // percent[count] = newPercent;
    // if (++count >= sizeof(percent))
    //   count = 0;
    // byte middle = (max(percent[0], percent[1]) == max(percent[1], percent[2])) ? max(percent[0], percent[2]) : max(percent[1], min(percent[0], percent[2]));
    
    return newPercent;
  }
  byte percent[8];
};

HallButton myHallButton[2] = {HallButton(3), HallButton(2)};
void gpio_callback(uint gpio, uint32_t events)
{
  byte hallButtonIndex = gpio == 3 ? 0 : 1;
  // byte secondHallButtonIndex = hallButtonIndex == 0 ? 1 : 0;
  unsigned long timer = time_us_64();
  myHallButton[hallButtonIndex].Pulse(timer, events == GPIO_IRQ_EDGE_RISE);
  // myHallButton[secondHallButtonIndex].Pulse(timer, gpio_get(myHallButton[secondHallButtonIndex].pin) != 0);
}

void setup()
{
  digitalWrite(23, HIGH);
  gpio_set_irq_enabled_with_callback(3, GPIO_IRQ_EDGE_FALL | GPIO_IRQ_EDGE_RISE, true, &gpio_callback);
  gpio_set_irq_enabled(2, GPIO_IRQ_EDGE_FALL | GPIO_IRQ_EDGE_RISE, true);
  _gpio_init(2);
  gpio_set_input_enabled(2, true);
  gpio_pull_up(2);
  _gpio_init(3);
  gpio_set_input_enabled(3, true);
  gpio_pull_up(3);
  Serial.begin(9600);
}
unsigned long flag;
byte counter = 0;
void loop()
{
  // int width = myHallButton[0].percent;
  // Serial.println(String(width));
  // if (Serial.available() > 0)
  //   parseSerial();
  uint64_t timer = millis();
  for (size_t i = 0; i < 2; i++)
  {
    byte percent = myHallButton[i].getPercent();
    if (timer > flag + 1)
    {
      if (i == 1)
        flag = timer;
      // for (size_t j = 0; j < sizeof(myHallButton->percent); j++)
      // {
      //   Serial.print(String(myHallButton[i].percent[j])+":");
      // }
      counter++;
      Serial.print(String(percent) + "\t");
    }
  }
  if (counter > 0)
  {
    Serial.print("\n");
    counter = 0;
  }
}
